/*
 * Created on 13 fvr. 2008
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package films;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class AccesBd
{
	Connection cnx = null;
	
	/* request et response passs en paramtres du doGet ()
	   ou doPost () de la servlet, et qui serviront a effectuer
	   un forward () vers la page d'exception si une exception survient  */
	HttpServletRequest request = null;
	HttpServletResponse response = null;

	public AccesBd (HttpServletRequest request,
								HttpServletResponse response) 
	{
		/* on mmorise les paramtres request et response qui  
		   serviront  effectuer le forward () vers la page d'exception,
		   si une exception survient */
		this.request = request;
		this.response = response;
		
		try
		{
			Class.forName("com.mysql.jdbc.Driver");
				
			String url = "jdbc:mysql://127.0.0.1:3306/bdfilms";
			cnx = DriverManager.getConnection (url, "root", "ipupp8v");
		}
		
		catch (ClassNotFoundException e)
		{
			displayException(e);
		} 
		
		catch (SQLException e)
		{
			displayException(e);
		} 
	}
	
	public Personne getPersonne (int id)
	{
		try
		{
			PreparedStatement st = cnx.prepareStatement(
				"select * from films where idfilms = ?");
				
			st.setInt(1, id);
			
			ResultSet rs = st.executeQuery();
			
			if (rs.next())
			{
				Personne p = new Personne ();
					
				p.setId(rs.getInt("idfilms"));
				p.setNom(rs.getString("nom"));
				p.setGenre(rs.getString("genre"));
				p.setFormatimages(rs.getString("formatimages"));
				p.setSupport(rs.getString("support"));
				p.setAuteur(rs.getString("auteur"));
				p.setAnnee(rs.getString("annee"));
				p.setCommentaire(rs.getString("commentaire"));
				
				rs.close ();
				st.close ();

				return p;					
			}
		}
		
		catch (SQLException e)
		{
			displayException(e);
		}
		
		return null;
				
	}

	public ListePersonne getListePersonne ()
	{
		try
		{
			Statement st = cnx.createStatement();
			ResultSet rs = st.executeQuery("select * from films");
			
			ListePersonne listePersonne = new ListePersonne ();
	
			while (rs.next())
			{
				Personne p = new Personne ();
					
				p.setId(rs.getInt("idfilms"));
				p.setNom(rs.getString("nom"));
				p.setGenre(rs.getString("genre"));
				p.setFormatimages(rs.getString("formatimages"));
				p.setSupport(rs.getString("support"));
				p.setAuteur(rs.getString("auteur"));
				p.setAnnee(rs.getString("annee"));
				p.setCommentaire(rs.getString("commentaire"));
				
					
				listePersonne.addPersonne(p);
			}
			
			rs.close ();
			st.close ();

			return listePersonne;
					
		}
		
		catch (SQLException e)
		{
			displayException(e);
		}
		
		return null;
				
	}
	
	public void insertPersonne (Personne p)
	{
		PreparedStatement st;
				
		try
		{
			if (getPersonne (p.getId()) == null)
			{
				st = cnx.prepareStatement(
					"insert into films (nom, genre, formatimages, support, auteur, annee, commentaire) " +
					"values (?,? , ?, ?, ?, ?, ?)");
				st.setString(1, p.getNom());
				st.setString(2, p.getGenre());
				st.setString(3, p.getFormatimages());
				st.setString(4, p.getSupport());
				st.setString(5, p.getAuteur());
				st.setString(6, p.getAnnee());
				st.setString(7, p.getCommentaire());
				
			}
			else
			{
				st = cnx.prepareStatement(
//					"update personne set nom = ?, prnom = ?, " +
//					"tlphone = ? where idPersonne = ?");
 					"update films set nom=?, genre = ?, formatimages = ?, " +
					"support = ?, auteur= ?, annee = ?, commentaire = ?  where idfilms = ?");

				st.setString(1, p.getNom());
				st.setString(2, p.getGenre());
				st.setString(3, p.getFormatimages());
				st.setString(4, p.getSupport());
				st.setString(5, p.getAuteur());
				st.setString(6, p.getAnnee());
				st.setString(7, p.getCommentaire());
							
				st.setInt(8, p.getId());
			}
				
			st.executeUpdate();
			
			st.close ();
		}
		
		catch (SQLException e)
		{
			displayException(e);
		}
	}
	
	public void removePersonne (int id)
	{
		try
		{
			PreparedStatement st = cnx.prepareStatement(
				"delete from films where idfilms = ?");
				
			st.setInt(1, id);
			
			st.executeUpdate();

			st.close ();
		}
		
		catch (SQLException e)
		{
			displayException(e);
		}
	}
	
	public void displayException (Exception e) 
						
	{
		RequestDispatcher disp = 
			  request.getRequestDispatcher ("exception.jsp");		
		
		request.setAttribute("exception", e);
		
		try
		{
			disp.forward(request, response);
		}
		catch (ServletException e1)
		{
		}
		catch (IOException e1)
		{
		}
	}
}
